/*
==========================================================================
	TESTMEM.CPP
		Test suite for the memory-instrumentation module.
  Copyright (c) 2000-2004 Daniel R. Collins. All rights reserved.
  You may freely copy this document, if copyright notice is maintained.
==========================================================================
*/

// Program Identification
#define APP_NAME          "TestMem"
#define AUTHOR_NAME       "Daniel R. Collins"
#define COPYRIGHT_YEAR    "2004"
#define VERSION_NUMBER    "1.04"


// Includes
#include <assert.h>
#include <stdio.h>
#include <new.h>        // define _set_new_handler
#include "meminst.h"


/*
-----------------------------------------
	Main function
-----------------------------------------
*/

int main (void)
	{
	// Begin
	printf("\n" APP_NAME " begining.\n");

  // Example of registering program out-of-mem handler (optional)
  _set_new_handler(memInstNewHandler);

  // Allocate memory, test, and report
  char *block1 = new char[1000];
  char *block2 = new char[2000];
  char *block3 = new char[5000];
  assert(memInstGetBlocks() == 3);
  assert(memInstGetBytes() == 8000);
	memInstReport();

  // Delete memory, test, and report
  delete block1;
  delete block2;
  delete block3;
  assert(memInstGetBlocks() == 0);
  assert(memInstGetBytes() == 0);
	memInstReport();

  // Finish
  printf(APP_NAME " finished successfully.\n");
	return 0;
	}

